<!--#include virtual="/.narodsys/metrika_counter.html"-->
<i style="background:url(//www.tns-counter.ru/V13a****yandex_ru/ru/CP1251/tmsec=narod_total/0)"></i>
<!--#include virtual="/.narodsys/direct.html"-->
/*****************************************************************************
**
** program_nx3_bolt_gaika_shaiba.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/


//-------------------------------------------------------
//  __
//.......................................................
//  
//  CSYS
// 
// 
//     
//-------------------------------------------------------

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif




#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>
#include <uf_csys.h>
#include <uf_modl.h>
#include <uf_defs.h>
#include <uf_mtx.h>


static	FILE*	prterr;
static	int		errorCode;

static	tag_t	parent_part;


//   
#define	PRTERR if(errorCode){PrintErrorMessage(errorCode,__LINE__);goto term;}


//   
static	void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"\n	errorCode=%d	message=%s	line=%d\n",
			errorCode,message,line);
		fflush(prterr);
		errorCode=0;
	}
}


//   
int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}


//   CSYS
int	CSYS_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_coordinate_system_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}



//  
int	face_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_face_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}




//  
int	point_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_point_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}






// 
int	do_it(void)
{

	tag_t*	component_group;
	int		component_count;

	

	//   
get_components:
	{
		char*	message="    ";
		char*	title=" ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_p_t	object;
		int		count;
		int		i;

		errorCode=UF_UI_select_with_class_dialog
		(message,title,scope,component_init_proc,NULL,&response,&count,&object);
		PRTERR;

		switch(response)
		{

		case UF_UI_BACK:
			goto get_components;

		case UF_UI_CANCEL:
			goto term;

		case UF_UI_OK:
			break;
		}

		//   ?
		if(count==0)
		{
			uc1601("      ",1);
			goto get_components;
		}

		//  
		for(i=0;i<count;i++)
		{
			errorCode=UF_DISP_set_highlight(object[i],0);
			PRTERR;
		}

		component_group=object;
		component_count=count;

	}

	double	matrix_values[9];
	double	csys_origin[3];

	//  CSYS
get_CSYS:
	{

		char*	message="   ";
		char*	title="  ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_t	object;
		double	cursor[3];
		tag_t	view;
		static	tag_t	base_CSYS;

		errorCode=UF_UI_select_with_single_dialog
		(message,title,scope,CSYS_init_proc,NULL,&response,&object,cursor,&view);
		PRTERR;

		switch(response)
		{

		case UF_UI_BACK:
			goto get_components;

		case UF_UI_CANCEL:
			goto term;

		case UF_UI_OK:
			break;

		case UF_UI_OBJECT_SELECTED:
			break;

		case UF_UI_OBJECT_SELECTED_BY_NAME:
			break;

		}

		if(object==NULL_TAG)
		{
			uc1601("    CSYS",1);
			goto get_CSYS;
		}


		//  CSYS
		errorCode=UF_DISP_set_highlight(object,0);PRTERR;

		base_CSYS=object;

		tag_t	matrix_id;

		
		errorCode=UF_CSYS_ask_csys_info(base_CSYS,&matrix_id,csys_origin);PRTERR;

		errorCode=UF_CSYS_ask_matrix_values(matrix_id,matrix_values);PRTERR;

	}




	tag_t	face_tag;


	// 
get_face:
	{

		char*	message=" ";
		char*	title=" ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_t	object;
		double	cursor[3];
		tag_t	view;


		errorCode=UF_UI_select_with_single_dialog
		(message,title,scope,face_init_proc,NULL,&response,&object,cursor,&view);
		PRTERR;

		switch(response)
		{

		case UF_UI_BACK:
			goto get_CSYS;

		case UF_UI_CANCEL:
			goto term;

		case UF_UI_OK:
			break;

		case UF_UI_OBJECT_SELECTED:
			break;

		case UF_UI_OBJECT_SELECTED_BY_NAME:
			break;

		}

		if(object==NULL_TAG)
		{
			uc1601("   ",1);
			goto get_face;
		}


		//  
		errorCode=UF_DISP_set_highlight(object,0);PRTERR;

		face_tag=object;


	}


	tag_p_t	point_group;
	int		point_count;


	//  
get_points:
	{

		char*	message="  ";
		char*	title="  ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_p_t	object;
		int		count;
		int		i;

		errorCode=UF_UI_select_with_class_dialog
		(message,title,scope,point_init_proc,NULL,&response,&count,&object);
		PRTERR;

		switch(response)
		{

		case UF_UI_BACK:
			goto get_face;

		case UF_UI_CANCEL:
			goto term;

		case UF_UI_OK:
			break;
		}

		//   ?
		if(count==0)
		{
			uc1601("    ",1);
			goto get_points;
		}

		//  
		for(i=0;i<count;i++)
		{
			errorCode=UF_DISP_set_highlight(object[i],0);
			PRTERR;
		}

		point_group=object;
		point_count=count;

	}



	//
	{
		int			i,j,k;
		double		point_coords[3];
		double		parm[2];
		double		face_pnt[3];
		double		u1[3],v1[3],u2[3],v2[3],unit_norm[3],radii[2];
		char part_name[ 256 + 1 ];
		char refset_name[ 30 + 1 ]; 
		char instance_name[ 30 + 1 ]; 
		double origin[ 3 ];
		
		double csys_matrix[ 9 ]; 
		double transform[ 4 ][ 4 ];
		double mtx16[16];
		double mtx9[9];
		UF_PART_load_status_t	error_status;
		int						layer=0;
		tag_t					instance;
		


		//  
		for(i=0;i<point_count;i++)
		{
			
			errorCode=UF_CURVE_ask_point_data
			(point_group[i],point_coords);PRTERR;

			errorCode=UF_MODL_ask_face_parm
			(face_tag,point_coords,parm,face_pnt);PRTERR;

			errorCode=UF_MODL_ask_face_props
			(face_tag,parm,face_pnt,u1,v1,u2,v2,unit_norm,radii);PRTERR;
			UF_MTX3_initialize(u1,v1,mtx9);
			


			for(j=0;j<component_count;j++)
			{
				
				errorCode=UF_ASSEM_ask_component_data
				(component_group[j],part_name,refset_name,instance_name,
				origin,csys_matrix,transform);PRTERR;
				
				errorCode=UF_MTX4_csys_to_csys
				(csys_origin,matrix_values+0,matrix_values+3,
				face_pnt,mtx9+0,mtx9+3,mtx16);PRTERR;
				
				UF_VEC3_add(csys_matrix+0,origin,csys_matrix+0);
				UF_VEC3_add(csys_matrix+3,origin,csys_matrix+3);

				UF_MTX4_vec3_multiply(origin,mtx16,origin);

				UF_MTX4_vec3_multiply(csys_matrix+0,mtx16,csys_matrix+0);
				UF_VEC3_sub(csys_matrix+0,origin,csys_matrix+0);

				UF_MTX4_vec3_multiply(csys_matrix+3,mtx16,csys_matrix+3);
				UF_VEC3_sub(csys_matrix+3,origin,csys_matrix+3);

                strcpy(refset_name,"");
				errorCode=UF_ASSEM_add_part_to_assembly
				(parent_part,part_name,refset_name,instance_name,
				origin,csys_matrix,layer,&instance,&error_status);PRTERR;

				if(error_status.n_parts>0)
				{
					for(k=0;k<error_status.n_parts;k++)
						fprintf(prterr,"\n error_status.file_names=%s "
						"\t error_status.statuses=%d"
						"\t i=%d \t j=%d \t k=%d line=%d\n",
						error_status.file_names[k],
						error_status.statuses[k],i,j,k,__LINE__);
					UF_free(error_status.statuses);
					UF_free_string_array
					(error_status.n_parts,error_status.file_names);
				}
			}//for(j=
		}//for(i=
	}//block

	UF_free(component_group);
	UF_free(point_group);



	goto term;
term:
	return errorCode;

}






/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	//   
	struct	tm*	newtime;
	time_t	aclock,start_time,finish_time;
	double	work_time;
	int		min,sec;

	
	time(&start_time);	// 

	//     D:
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
		goto label_clock;

	//     D:
	if((prterr=fopen("C:\\temp\\prterr.txt","w"))!=NULL)
		goto label_clock;



	uc1601("    ",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"\n <bolt_gaika_shaiba>	HAS STARTED		line=%d\n",__LINE__);
	
	fprintf(prterr,"\n    :	%s\n\n",asctime(newtime));

	errorCode=UF_initialize();PRTERR;


	//     
	parent_part=UF_PART_ask_display_part();
	if(parent_part==NULL_TAG)
	{
		uc1601("  ",1);
		fprintf(prterr,"\n	   	line=%d\n",__LINE__);
		goto term;
	}

	*returnCode=do_it();

	errorCode=UF_terminate();PRTERR;

	
term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n <bolt_gaika_shaiba>	HAS FINISHED	line=%d\n",__LINE__);
	fprintf(prterr,"\n working time is %u min   %u sec\n",min,sec);
		
	
	fflush(prterr);
	fclose(prterr);
	return;
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}